CUTLASS: cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize > Struct Template Reference

| CUTLASS CUDA Templates for Linear Algebra Subroutines and Solvers

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize > Struct Template Reference

Template based on element size (in bits) - defined in terms of pitch-linear memory.

`#include <tensor_op_multiplicand_sm70.h>`

## Public Types
using | Index = int32_t
| Index type used for coordinates. More...
using | LongIndex = int64_t
| Long index type used for offsets. More...
using | TensorCoord = PitchLinearCoord
| Logical coordinate. More...
using | Stride = Coord< kStrideRank, Index, LongIndex >
| Stride vector. More...
using | TileShape = PitchLinearShape< 8, 4 >
| Fundamental tile shape in units of vectors. More...
using | PartitionShape = PitchLinearShape< 8, 2 >
| Fundamental partition shape in units of vectors. More...
using | PartitionCount = PitchLinearShape< TileShape::kContiguous/PartitionShape::kContiguous, TileShape::kStrided/PartitionShape::kStrided >
using | AccessCount = PitchLinearShape< PartitionShape::kContiguous, PartitionShape::kStrided >

## Public Member Functions
CUTLASS_HOST_DEVICE | VoltaTensorOpMultiplicandCongruous (Index ldm=0)
| Ctor. More...
CUTLASS_HOST_DEVICE | VoltaTensorOpMultiplicandCongruous (Stride stride)
| Ctor. More...
CUTLASS_HOST_DEVICE LongIndex | operator() (TensorCoord const &coord) const
CUTLASS_HOST_DEVICE Stride | stride () const
| Returns the stride of the layout. More...
CUTLASS_HOST_DEVICE Stride & | stride ()
| Returns the stride of the layout. More...
CUTLASS_HOST_DEVICE LongIndex | capacity (TensorCoord const &extent) const
| Compute the number of contiguous elements needed to store a tensor with the given size. More...

## Static Public Member Functions
static CUTLASS_HOST_DEVICE VoltaTensorOpMultiplicandCongruous | packed (TensorCoord const &extent)
| Helper returns a layout to a tightly packed tensor. More...

## Static Public Attributes
static int const | kRank = 2
| Logical rank of tensor. More...
static int const | kStrideRank = 1
| Rank of stride vector. More...
static int const | kAccessSize = 128
| This layout is optimized for 128b accesses. More...
static int const | kElementSize = ElementSize
static int const | kElementsPerAccess = kAccessSize / kElementSize

## Member Typedef Documentation

template<int ElementSize>

using cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::AccessCount = PitchLinearShape< PartitionShape::kContiguous, PartitionShape::kStrided >

template<int ElementSize>

using cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::Index = int32_t

template<int ElementSize>

using cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::LongIndex = int64_t

template<int ElementSize>

using cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::PartitionCount = PitchLinearShape< TileShape::kContiguous / PartitionShape::kContiguous, TileShape::kStrided / PartitionShape::kStrided >

template<int ElementSize>

using cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::PartitionShape = PitchLinearShape<8, 2>

template<int ElementSize>

using cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::Stride = Coord<kStrideRank, Index, LongIndex>

template<int ElementSize>

using cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::TensorCoord = PitchLinearCoord

template<int ElementSize>

using cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::TileShape = PitchLinearShape<8, 4>

## Constructor & Destructor Documentation

template<int ElementSize>

CUTLASS_HOST_DEVICE cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::VoltaTensorOpMultiplicandCongruous | ( | Index | ldm = `0` | ) |
| inline

template<int ElementSize>

CUTLASS_HOST_DEVICE cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::VoltaTensorOpMultiplicandCongruous | ( | Stride | stride | ) |
| inline

## Member Function Documentation

template<int ElementSize>

CUTLASS_HOST_DEVICE LongIndex cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::capacity | ( | TensorCoord const & | extent | ) | const
| inline

template<int ElementSize>

CUTLASS_HOST_DEVICE LongIndex cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::operator() | ( | TensorCoord const & | coord | ) | const
| inline

Returns the offset of a coordinate in linear memory. Assumes coordinate has convention (contiguous, strided)

template<int ElementSize>

static CUTLASS_HOST_DEVICE VoltaTensorOpMultiplicandCongruous cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::packed | ( | TensorCoord const & | extent | ) |
| inlinestatic

template<int ElementSize>

CUTLASS_HOST_DEVICE Stride cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::stride | ( |  | ) | const
| inline

template<int ElementSize>

CUTLASS_HOST_DEVICE Stride& cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::stride | ( |  | ) |
| inline

## Member Data Documentation

template<int ElementSize>

int const cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::kAccessSize = 128
| static

template<int ElementSize>

int const cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::kElementSize = ElementSize
| static

template<int ElementSize>

int const cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::kElementsPerAccess = kAccessSize / kElementSize
| static

template<int ElementSize>

int const cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::kRank = 2
| static

template<int ElementSize>

int const cutlass::layout::VoltaTensorOpMultiplicandCongruous< ElementSize >::kStrideRank = 1
| static

The documentation for this struct was generated from the following file:

- tensor_op_multiplicand_sm70.h